import string

def getTextContent (element):
    '''
    Returns recursively all the text content from the given element. 
    This can be used in both, odt_inspector and docx_inspector.
    
    element -- the element to be checked 
    return -- all text content from element and descendants
    '''
    elementsChildList = element.childNodes
    content = ''
    
    for childElement in elementsChildList:
        if childElement.nodeType == childElement.TEXT_NODE:
            content += childElement.nodeValue
        else:
            content += getTextContent(childElement)
    return content

def checkStringFromContent(element,wantedString):  
    textContent = getTextContent(element)
    str(textContent)
    if string.find(textContent,wantedString)==-1:
        return False
    else:
        return True
    
def checkIfEmailAddress (element):
    '''Checks if element contains e-mail address.
    @-char is identifier.
    Return e-mail address, None if element didn't contain e-mail.
    '''
    if checkStringFromContent(element,'@'):
        return getTextContent(element)
    return None

def getDescendants (element,elementList):
    '''Get elements all descendants.
    element is the node which descendants have to find
    elementList is empty list
    return list of all descendants
    '''
    elementChildren = element.childNodes
    
    for element in elementChildren:
        elementList.append(element)
        if element.hasChildNodes():
            getDescendants(element,elementList)
    return elementList