#!/usr/bin/python
# -*- coding: UTF-8 -*-


'''
Created on 3.3.2011

@author: olkauppi
'''
import sys
import zipfile
import xml.dom.minidom
import fnmatch

#filename ='Yliopisto_opiskelu.odt'
#
#if zipfile.is_zipfile(filename):
#    myodf = zipfile.ZipFile(filename)
#    metaXml = myodf.read('meta.xml')
#    metaDom = xml.dom.minidom.parseString(metaXml)

  
#===============================================================================
# def main():
#    printMetaInformation ()
#    if fnmatch.fnmatch(filename,'*.odt'):
#        printOdtStatistic() 
#    elif fnmatch.fnmatch(filename,'*.ods'):  
#        printOdsStatistic()
#    elif fnmatch.fnmatch(filename,'*.odp'):  
#        printOdpStatistic()
#===============================================================================
    
          
def getMetaInformation(documentDict,elementTagName):
    element=documentDict['meta.xml'].getElementsByTagName(elementTagName)
    if element:
        return element[0].firstChild.nodeValue
    else:
        return 'ei ole maaritetty'
    
def getDocumentStatistic(documentDict,attributeName):
    element=documentDict['meta.xml'].getElementsByTagName('meta:document-statistic')
    if element:
        return element[0].getAttribute (attributeName)
    else:
        return 'Statistiikkaa ei ole maaritetty'

def printMetaInformation ():
    title = getMetaInformation ('dc:title')  
    creationDate=getMetaInformation ('meta:creation-date')  
    author = getMetaInformation ('meta:initial-creator')
    editingDuration = getMetaInformation('meta:editing-duration')
    lastModifyDate = getMetaInformation ('dc:date')
    lastModifiedBy = getMetaInformation('dc:creator')
    revision = getMetaInformation ('meta:editing-cycles')
    
    print "title:", title
    print "luonti pvm ja aika:",creationDate
    print "alkuperainen tekija:", author
    print "editointi aika:", editingDuration
    print "viimeisin muokkaus pvm ja kellonaika:", lastModifyDate
    print "viimeisin muokkaaja:", lastModifiedBy
    print "revisio numero:",revision
    
def getMeta(documentDict):
    meta = {'dc:title': None,
    'meta:creation-date': None,
    'meta:initial-creator': None,
    'meta:editing-duration': None,
    'dc:date': None,
    'dc:creator': None,
    'meta:editing-cycles': None}
    
    for metaName in meta.keys():
        meta[metaName] = getMetaInformation(documentDict,metaName)
       
    return meta 

    

def printOdtStatistic ():
    tables = getDocumentStatistic('meta:table-count')
    images = getDocumentStatistic('meta:image-count')
    objects = getDocumentStatistic('meta:object-count')
    pages = getDocumentStatistic('meta:page-count')
    paragraphs = getDocumentStatistic('meta:paragraph-count')
    words = getDocumentStatistic('meta:word-count')
    characters = getDocumentStatistic('meta:character-count')
          
    print "taulukoita:", tables
    print "kuvia:", images
    print "objekteja:", objects
    print "sivuja: ", pages
    print "kappaleita", paragraphs
    print "sanoja: ", words
    print "merkkeja:", characters
    
def printOdsStatistic ():
    tables = getDocumentStatistic('meta:table-count')
    cells = getDocumentStatistic('meta:cell-count')
    objects = getDocumentStatistic('meta:object-count')
              
    print "taulukoita:", tables
    print "soluja:", cells
    print "objekteja:", objects

def printOdpStatistic ():
    objects = getDocumentStatistic('meta:object-count')
    print "objekteja:", objects
    
    
if __name__ == "__main__":
    #main()
    print''