#!/usr/bin/python
# -*- coding: UTF-8 -*-

'''
Created on Mar 17, 2011

@author: juiitamm
'''

import docx_inspector, odt_inspector
import zipfile, xml.dom.minidom
from requirements import Requirements
import sys
from urllib import urlopen
#from errorEnums import wordProcessingErros

inspectorDict = {'odt':odt_inspector,'docx':docx_inspector}
# @see: more attributes before inspect
#checkers = { 'TOC': word_processing.checkToc }

def makeDict(file, fileExtension):
    
    document = {'fileExtension': fileExtension}
    
    zipDocument = zipfile.ZipFile(file)
    
    for data in zipDocument.filelist:
        try:
            document[data.filename] = xml.dom.minidom.parseString(zipDocument.read(data.filename))
        except:
            document[data.filename] = zipDocument.read(data.filename)
    return document

def printErrors (errorList):
    for error in errorList:
        print error
    

#def processRequirements(inspector, document, feedback): # tarpeellisia kaikki parametrit?
def processRequirements(inspector, document, requirements, results):
    
# TODO: make odt and docx-inspectors' interface similar.
    
    # Not like this in the future:
    
    for requirement in requirements.requirements:
        _checkers[requirement.name](inspector, requirement, document, results)
      
        
    #_checkers['TOC'](inspector, True, document, results)
    #_checkers['Image'](inspector, True, document, results)
    #_checkers['CoverPage'](inspector, True, document, results)
    
#    if isinstance(inspector.getPageMarginals(documentDict), dict) is not True:
#        feedbackDict['common'].append(inspector.getPageMarginals(documentDict))
#    
#    '''FILE'''
#    #file.append(filename)
#    #file.append(errors)
#    file.append( 'tekijä: ' + inspector.getMeta(documentDict)['dc:creator'])
#    file.append( 'title: ' + inspector.getMeta(documentDict)['dc:title'])
#    file.append( 'luotu: ' + inspector.getMeta(documentDict)['meta:creation-date'])
#    
#    '''STRUCTURE'''
#    if inspector.checkSectionAmount is False:
#        feedbackDict['structure'].append ("osanvaihtoja liian vähän (kannen, sis.luettelon ja tekstin oltava omissa osissa)")
#    
#    '''COMMON'''   
#    #results = 'common' 
#    if inspector.checkTOC(documentDict) is False:
#        feedbackDict['common'].append ("There is no table of contents at all.")
#    if inspector.getPageMarginals(documentDict) is False:
#        feedbackDict['common'].append ("Page margins...")
#        
#    '''CONTENT'''
#    #results = 'content'
#    if  inspector.checkIllegalStyling(documentDict) is False:
#        feedbackDict['content'].append("Dokumentissa on kaytetty tyylien ulkopuolista muotoilua")
#   
#    '''STYLES'''
#    
#    '''NUMBERS'''
#    
#    '''FORMATTING'''
#    if inspector.findEmptyParagraphs(documentDict) != 0:
#        feedbackDict['formatting'].append("dokumentissa "+ str(inspector.findEmptyParagraphs(documentDict))+" ylimaaraista tyhjaa kappaletta")
#    
#    '''OBJECTS'''
#    if inspector.checkImage(documentDict) is False:
#        feedbackDict['objects'].append("There is no image at all.")
#    
#    '''FOR TESTING'''  
def printResults(resultsDict):
#    print "FILE:"
#    for i in file:
#        print i
    print "\nERRORS:"
    for feed in resultsDict.keys():
        print feed.upper(),
        if resultsDict[feed]:
            print ''
            for i in resultsDict[feed]:
                print "  -",i
        else:
            print '...OK'
    
        
    #print "VIRHEET:"
    #printErrors (error)
    
def checkBooleanRequirement(function, requirement, document, results):
    '''Inspector methods return a boolean'''
    expectedValue = requirement.expectedValue
    
    if function(document) is not expectedValue:
        results[requirement.category].append(requirement.getErrorMessage())
        return False     
    return True
    
def checkDictRequirement(function, requirement, document, results):
    ''' Inspector methods return a dictionary.'''
    #FIXME: requirement's expectedValue is always a string and not the same type as inspector return value. 
    # Handle the types!!
    inspectorData = function(document)
    if inspectorData is False:
        results[requirement.category].append(requirement.getErrorMessage())
        return
    
    for key in requirement.expectedValue.keys():
        #if inspectorData[key] != requirement.expectedValue[key]:
        if str(inspectorData[key]) != str(requirement.expectedValue[key]):
            results[requirement.category].append(requirement.getErrorMessage())
        #elif function(document) is not 'True':
        #    results[requirement.category].append(requirement.getErrorMessage())
        
def checkRequirementEndNoteFootNote(inspector, requirement, document, results):
    checkBooleanRequirement(inspector.checkEndnotesAndFootnotes, requirement, document, results)
    
def checkRequirementMargins(inspector, requirement, document, results):
    checkDictRequirement(inspector.getPageMarginals, requirement, document, results)

def checkRequirementPageSize(inspector, requirement, document, results):
    checkDictRequirement(inspector.getPageSize, requirement, document, results)
    
def checkRequirementCoverPage(inspector, requirement, document, results):
    checkDictRequirement(inspector.checkCoverPage, requirement, document, results)
    
def checkRequirementHeadingNumbering(inspector, requirement, document, results):
    expectedValue = requirement.expectedValue
    
    errorIdsAndPositions = { 'manualNumbering': None, 'styleNotUsed': None, 'differentNumbering': None, 
                            'notMultilevel': None, 'outlineLvl': None, 'numStart': None, 'numWrong': None, 
                            'numFormat': None} #@see requirements.xml - <errorvalue>
    
    returnValue = inspector.checkHeadingNumbering(document, errorIdsAndPositions)

    if returnValue is not expectedValue:
        results[requirement.category].append(requirement.getErrorMessage()) #DEFAULT
    
    if len( errorIdsAndPositions.values() ) != 0:
        for key in errorIdsAndPositions.keys():
            if errorIdsAndPositions[key] is not None:
                results[requirement.category].append(requirement.getErrorMessage(key) + ' ' + errorIdsAndPositions[key])
                # esim. - Seuraavan otsikkotyylin monitasoinen numerointi on väärin: Otsikko2
                    
def checkRequirementStyles(inspector, requirement, document, results):
    #FIXME: requirement's expectedValue is always a string and not the same type as inspector return value. 
    # Handle the types!!
    inspectorData = inspector.getStyle(document, requirement.expectedValue['styleName'])
    
    if inspectorData is False:
        results[requirement.category].append(requirement.getErrorMessage())
        return
    
    results[requirement.category].append(requirement.expectedValue['styleName'])
    for key in requirement.expectedValue.keys():
        #if inspectorData[key] != requirement.expectedValue[key]:
        if str(inspectorData[key]) != str(requirement.expectedValue[key]):
            results[requirement.category].append(requirement.getErrorMessage(key))
        #elif function(document) is not 'True':
        #    results[requirement.category].append(requirement.getErrorMessage())
#    coverPageData = inspector.checkCoverPage(document)
#    
#    if coverPageData['name'] is False:
#        results['common'].append('Ohjelman asetuksissa asetettu nimi puuttuu etusivulta.')
#    
#    if coverPageData['title'] is False:
#        results['common'].append('Ohjelman asetuksissa asetettu työn nimi puuttuu etusivulta.')
#    
#    if coverPageData['email'] is False:
#        results['common'].append('Etusivun sähköpostiosoite on virheellinen.')
        
def checkRequirementTOC(inspector, requirement, document, results):
    if checkBooleanRequirement(inspector.checkTOC, requirement, document, results) is True:
        checkBooleanRequirement(inspector.checkTocContent, requirement, document, results)
    
#    expectedValue = requirement.expectedValue
#    
#    if inspector.checkTOC(document) is not expectedValue:
#        results['common'].append(requirement.getErrorMessage())
#        return
#    if inspector.checkTocContent(document) is not expectedValue:
#        results['common'].append(requirement.getErrorMessage('2'))
    
def checkRequirementImages(inspector, requirement, document, results):
    checkBooleanRequirement(inspector.checkImages, requirement, document, results)
#    expectedValue = requirement.expectedValue
#    
#    if inspector.checkImages(document) is not expectedValue:
#        results['objects'].append(requirement.getErrorMessage())

_checkers = { 'Styles': checkRequirementStyles, 'TOC': checkRequirementTOC, 'Image' : checkRequirementImages, 'CoverPage': checkRequirementCoverPage,
             'PageSize' : checkRequirementPageSize, 'Margins' : checkRequirementMargins,
             'EndNoteFootNote' : checkRequirementEndNoteFootNote, 'HeadingNumbering': checkRequirementHeadingNumbering}

def inspect(zipFile, requirementsFileName, fileExtension):
    
    #TODO: extract the zip-file, processRequirements.
    
    #print zip.filename
    #print fileExtension
    #docx = docx_inspector.DocxReader()
    results = {'common':[], 'structure':[], 'content':[], 'styles':[], 'numbers':[], 'formatting':[], 'objects':[]}
    document = makeDict(zipFile, fileExtension)
    inspector = inspectorDict[document['fileExtension']]
    
    #FIXME: hard coded!!
    # For gui testing:
    
    if requirementsFileName == "":
        reqFilename = urlopen('http://sovellusprojektit.it.jyu.fi/parsi/sovellus/sampleFiles/xml/requirements_test1.xml')
    else:
        reqFilename = 'sampleFiles/xml/requirements_test1.xml'
    reqDom = xml.dom.minidom.parse(reqFilename)
    requirements = Requirements(reqDom)
    
    processRequirements(inspector, document, requirements, results)
    
    return results
    #req = requirements.Requirements(requirementsFileName)
    
#    odtWidth = odt_inspector.searhPageLayout('fo:page-width')
#    
#    if int(odtWidth) == 2:
#        print "Sivun leveys on kunnossa"
#    else: print "sivun leveys on " + odtWidth
    
#    req.printRequirements("normal")
#    print req.getRequirements("normal", "suomi")
#    print req.getRequirements("normal", "kirjasin")
#    print req.getRequirements("normal", "kirjasinkoko")

if __name__ == '__main__':
#    inspect("foo", "vaatimukset.xml", "foobar")

    #filename = 'sampleFiles/docx/sivunumerointi_oikein_hdr_ftr.docx'
    #filename = 'sampleFiles/docx/tekstinkasittely.docx'
    #filename = 'sampleFiles/docx/teemakokeilu.docx'
    filename = 'sampleFiles/docx/docx_demo.docx'
    #filename = 'sampleFiles/docx/otsikko_numerointi_ei_otsikko1.docx'
#    filename = 'sampleFiles/docx/index_lorem1.docx'
    #filename ='sampleFiles/odt/Yliopisto_opiskelu.odt'
    #filename ='sampleFiles/odt/toc_handmade.odt'
    
    #filename = 'sampleFiles/docx/index_lorem2.docx'
    #filename = 'sampleFiles/docx/index_lorem2_whitespace_asterix.docx'
    #filename = 'sampleFiles/docx/Teija_Holtta.docx' # asetus19.xml, see below
    
    reqFilename = 'sampleFiles/xml/requirements_test1.xml'
    #zipFile = zipfile.ZipFile(filename)
    printResults(inspect(filename, reqFilename, "docx"))
